// Inventory.vue

<template>
    <div class="logo" style="height:150px"></div>
    <h1>Inventory</h1>
    <div>
      <router-link to="/">Back</router-link>
      <p></p>
    </div>
    <p></p>
    <router-link to="/session" custom v-slot="{navigate}"><button class="start-inv-btn" @click="navigate" role="link">Start Inventory Session</button></router-link>
    <p></p>
    <div>
      <p></p>
      <button @click.prevent="quickEntry" style="margin-left: 1rem">Quick Entry</button>
      <form id="quickEntry">
          <input id="newUPC" placeholder="Enter UPC">
          <input id="newName" placeholder="Enter item name">
          <input id="newQuantity" placeholder="Enter quantity">
        <div>
          <button @click="confirmItem" type="button">add item</button>
          <button @click="cancel" type="button">cancel</button>
        </div>
      </form>
      <div v-show="addItemStatus === 'errored'">Could not submit entry.</div>
      <div v-show="addItemStatus === 'error:upc'">UPC code error</div>
      <div v-show="addItemStatus === 'error:quantity'">Quantity must be a number</div>
    </div>
    <div>
      <table style="margin-left: auto; margin-right: auto">
        <thead>
          <tr>
            <th style="text-align: left; width: 10rem;">
              UPC
            </th>
            <th style="text-align: left; width: 20rem;">
              Name
            </th>
            <th style="text-align: left; width: 5rem;">
              Quantity
            </th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="item in items" :key="item.upc">
            <td style="text-align: left" v-if="item">{{item.upc}}</td>
            <td style="text-align: left" v-if="item">{{item.name}}</td>
            <td style="text-align: left" v-if="item">{{item.quantity}}</td>
          </tr>
        </tbody>
      </table>
      <div v-show="status === 'errored'">Could not load items.</div>
      <div v-show="status === 'loading'">Loading items. Please wait...</div>
      <div v-show="status === 'loaded' && items.length === 0">No items.</div>
    </div>
</template>

<script>
import axios from 'axios';
import { BACKEND_BASE_URL } from '../env.js';

export default {
  name: "Inventory",
  data(){
    return {
      items: [],
      status: 'loading', // loaded, errored
      addItemStatus: 'idle', // sending, errored
    }
  }, 
  created: function() {
    axios.get(BACKEND_BASE_URL + "/inventory")
        .then(response => {
            this.items = response.data;
            this.status = 'loaded';
        })
        .catch (error => {
          console.error(error);
          this.status = 'errored';
        })
  },
  methods: {
    quickEntry() {
      let form = document.getElementById("quickEntry");
      form.style.display = "block";
    },
    async confirmItem() {
      let form = document.getElementById("quickEntry");
      let newUPC = document.getElementById("newUPC").value;
      let newName = document.getElementById("newName").value;
      let newQuantity = document.getElementById("newQuantity").value;
      if (!(/\d{12}/.test(newUPC))) {
        this.addItemStatus='error:upc';
        return;
      }
      if (!(/\d{12}/.test(newUPC))) {
        this.addItemStatus='error:upc';
        return;
      }
      try {
        const putRes = await axios.put(BACKEND_BASE_URL + "/inventory", {upc:newUPC,name:newName,quantity:parseInt(newQuantity)});
        console.log(putRes);
      }
      catch (error) {
        console.error(error);
        this.addItemStatus = 'errored';
      }
      axios.get(BACKEND_BASE_URL + "/inventory")
        .then(response => {
            this.items = response.data;
            this.status = 'loaded';
        })
        .catch (error => {
          console.error(error);
          this.status = 'errored';
        })
      form.style.display = "none";
    },
    cancel() {
      let form = document.getElementById("quickEntry");
      form.style.display = "none";
    }
  }
}
</script>

<style>
th {
  border-bottom:1px solid black;
}

#quickEntry {
    display: none
  }

.logo {
  background-image: url("../public/wne-logo-2.png");
  background-repeat: no-repeat;
  background-size: 40%;
  background-position: center
}

.start-inv-btn {
  width: 21%;
  height: 20%;
  font-size: 1.2rem;
  font-weight: bold;
  margin-bottom: 1rem;
  border-radius: 1rem;
  padding-top: .2rem;
  padding-bottom: .2rem;
}

.start-inv-btn:hover {
  color: blue
}

@media screen and (min-width: 1800px) {
  .logo {
    background-size: 30%;
  }
}
</style>